# generated by datamodel-codegen:
#   filename:  sarif-schema-2.1.0.json
#   timestamp: 2023-08-15T15:25:24+00:00

from __future__ import annotations

from datetime import datetime
from enum import Enum
from typing import Dict, List, Optional

from pydantic import (
    AnyUrl,
    BaseModel,
    ConfigDict,
    Field,
    RootModel,
    confloat,
    conint,
    constr,
)


class Version(Enum):
    field_2_1_0 = '2.1.0'


class Role(Enum):
    analysisTarget = 'analysisTarget'
    attachment = 'attachment'
    responseFile = 'responseFile'
    resultFile = 'resultFile'
    standardStream = 'standardStream'
    tracedFile = 'tracedFile'
    unmodified = 'unmodified'
    modified = 'modified'
    added = 'added'
    deleted = 'deleted'
    renamed = 'renamed'
    uncontrolled = 'uncontrolled'
    driver = 'driver'
    extension = 'extension'
    translation = 'translation'
    taxonomy = 'taxonomy'
    policy = 'policy'
    referencedOnCommandLine = 'referencedOnCommandLine'
    memoryContents = 'memoryContents'
    directory = 'directory'
    userSpecifiedConfiguration = 'userSpecifiedConfiguration'
    toolSpecifiedConfiguration = 'toolSpecifiedConfiguration'
    debugOutputFile = 'debugOutputFile'


class Level(Enum):
    none = 'none'
    note = 'note'
    warning = 'warning'
    error = 'error'


class PropertyBag(BaseModel):
    model_config = ConfigDict(
        extra='allow',
    )
    tags: Optional[List[str]] = Field(
        [],
        description='A set of distinct strings that provide additional information.',
        min_length=0,
    )


class DeprecatedGuid(RootModel):
    root: constr(
        pattern=r'^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-5][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}$'
    )


class ReportingConfiguration(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    enabled: Optional[bool] = Field(
        True,
        description='Specifies whether the report may be produced during the scan.',
    )
    level: Optional[Level] = Field(
        'warning', description='Specifies the failure level for the report.'
    )
    rank: Optional[confloat(ge=-1.0, le=100.0)] = Field(
        -1.0,
        description='Specifies the relative priority of the report. Used for analysis output only.',
    )
    parameters: Optional[PropertyBag] = Field(
        None, description='Contains configuration information specific to a report.'
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the reporting configuration.',
    )


class Kind(Enum):
    notApplicable = 'notApplicable'
    pass_ = 'pass'
    fail = 'fail'
    review = 'review'
    open = 'open'
    informational = 'informational'


class BaselineState(Enum):
    new = 'new'
    unchanged = 'unchanged'
    updated = 'updated'
    absent = 'absent'


class ColumnKind(Enum):
    utf16CodeUnits = 'utf16CodeUnits'
    unicodeCodePoints = 'unicodeCodePoints'


class Kind1(Enum):
    inSource = 'inSource'
    external = 'external'


class State(Enum):
    accepted = 'accepted'
    underReview = 'underReview'
    rejected = 'rejected'


class Importance(Enum):
    important = 'important'
    essential = 'essential'
    unimportant = 'unimportant'


class Content(Enum):
    localizedData = 'localizedData'
    nonLocalizedData = 'nonLocalizedData'


class ToolComponentReference(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    name: Optional[str] = Field(
        None, description="The 'name' property of the referenced toolComponent."
    )
    index: Optional[conint(ge=-1)] = Field(
        -1, description='An index into the referenced toolComponent in tool.extensions.'
    )
    guid: Optional[
        constr(
            pattern=r'^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-5][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}$'
        )
    ] = Field(None, description="The 'guid' property of the referenced toolComponent.")
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the toolComponentReference.',
    )


class Address(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    absoluteAddress: Optional[conint(ge=-1)] = Field(
        -1,
        description='The address expressed as a byte offset from the start of the addressable region.',
    )
    relativeAddress: Optional[int] = Field(
        None,
        description='The address expressed as a byte offset from the absolute address of the top-most parent object.',
    )
    length: Optional[int] = Field(
        None, description='The number of bytes in this range of addresses.'
    )
    kind: Optional[str] = Field(
        None,
        description="An open-ended string that identifies the address kind. 'data', 'function', 'header','instruction', 'module', 'page', 'section', 'segment', 'stack', 'stackFrame', 'table' are well-known values.",
    )
    name: Optional[str] = Field(
        None, description="A name that is associated with the address, e.g., '.text'."
    )
    fullyQualifiedName: Optional[str] = Field(
        None,
        description='A human-readable fully qualified name that is associated with the address.',
    )
    offsetFromParent: Optional[int] = Field(
        None,
        description='The byte offset of this address from the absolute or relative address of the parent object.',
    )
    index: Optional[conint(ge=-1)] = Field(
        -1,
        description='The index within run.addresses of the cached object for this address.',
    )
    parentIndex: Optional[conint(ge=-1)] = Field(
        -1, description='The index within run.addresses of the parent object.'
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the address.',
    )


class LogicalLocation(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    name: Optional[str] = Field(
        None,
        description='Identifies the construct in which the result occurred. For example, this property might contain the name of a class or a method.',
    )
    index: Optional[conint(ge=-1)] = Field(
        -1, description='The index within the logical locations array.'
    )
    fullyQualifiedName: Optional[str] = Field(
        None,
        description='The human-readable fully qualified name of the logical location.',
    )
    decoratedName: Optional[str] = Field(
        None,
        description='The machine-readable name for the logical location, such as a mangled function name provided by a C++ compiler that encodes calling convention, return type and other details along with the function name.',
    )
    parentIndex: Optional[conint(ge=-1)] = Field(
        -1,
        description='Identifies the index of the immediate parent of the construct in which the result was detected. For example, this property might point to a logical location that represents the namespace that holds a type.',
    )
    kind: Optional[str] = Field(
        None,
        description="The type of construct this logical location component refers to. Should be one of 'function', 'member', 'module', 'namespace', 'parameter', 'resource', 'returnType', 'type', 'variable', 'object', 'array', 'property', 'value', 'element', 'text', 'attribute', 'comment', 'declaration', 'dtd' or 'processingInstruction', if any of those accurately describe the construct.",
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the logical location.',
    )


class Message(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    text: Optional[str] = Field(None, description='A plain text message string.')
    markdown: Optional[str] = Field(None, description='A Markdown message string.')
    id: Optional[str] = Field(None, description='The identifier for this message.')
    arguments: Optional[List[str]] = Field(
        [],
        description='An array of strings to substitute into the message string.',
        min_length=0,
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the message.',
    )


class MultiformatMessageString(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    text: str = Field(..., description='A plain text message string or format string.')
    markdown: Optional[str] = Field(
        None, description='A Markdown message string or format string.'
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the message.',
    )


class Rectangle(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    top: Optional[float] = Field(
        None,
        description="The Y coordinate of the top edge of the rectangle, measured in the image's natural units.",
    )
    left: Optional[float] = Field(
        None,
        description="The X coordinate of the left edge of the rectangle, measured in the image's natural units.",
    )
    bottom: Optional[float] = Field(
        None,
        description="The Y coordinate of the bottom edge of the rectangle, measured in the image's natural units.",
    )
    right: Optional[float] = Field(
        None,
        description="The X coordinate of the right edge of the rectangle, measured in the image's natural units.",
    )
    message: Optional[Message] = Field(
        None, description='A message relevant to the rectangle.'
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the rectangle.',
    )


class ReportingDescriptorReference(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    id: Optional[str] = Field(None, description='The id of the descriptor.')
    index: Optional[conint(ge=-1)] = Field(
        -1,
        description='The index into an array of descriptors in toolComponent.ruleDescriptors, toolComponent.notificationDescriptors, or toolComponent.taxonomyDescriptors, depending on context.',
    )
    guid: Optional[
        constr(
            pattern=r'^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-5][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}$'
        )
    ] = Field(None, description='A guid that uniquely identifies the descriptor.')
    toolComponent: Optional[ToolComponentReference] = Field(
        None,
        description='A reference used to locate the toolComponent associated with the descriptor.',
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the reporting descriptor reference.',
    )


class ReportingDescriptorRelationship(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    target: ReportingDescriptorReference = Field(
        ..., description='A reference to the related reporting descriptor.'
    )
    kinds: Optional[List[str]] = Field(
        ['relevant'],
        description="A set of distinct strings that categorize the relationship. Well-known kinds include 'canPrecede', 'canFollow', 'willPrecede', 'willFollow', 'superset', 'subset', 'equal', 'disjoint', 'relevant', and 'incomparable'.",
    )
    description: Optional[Message] = Field(
        None, description='A description of the reporting descriptor relationship.'
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the reporting descriptor reference.',
    )


class RunAutomationDetails(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    description: Optional[Message] = Field(
        None,
        description="A description of the identity and role played within the engineering system by this object's containing run object.",
    )
    id: Optional[str] = Field(
        None,
        description="A hierarchical string that uniquely identifies this object's containing run object.",
    )
    guid: Optional[
        constr(
            pattern=r'^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-5][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}$'
        )
    ] = Field(
        None,
        description="A stable, unique identifer for this object's containing run object in the form of a GUID.",
    )
    correlationGuid: Optional[
        constr(
            pattern=r'^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-5][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}$'
        )
    ] = Field(
        None,
        description="A stable, unique identifier for the equivalence class of runs to which this object's containing run object belongs in the form of a GUID.",
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the run automation details.',
    )


class TranslationMetadata(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    name: str = Field(
        ..., description='The name associated with the translation metadata.'
    )
    fullName: Optional[str] = Field(
        None, description='The full name associated with the translation metadata.'
    )
    shortDescription: Optional[MultiformatMessageString] = Field(
        None, description='A brief description of the translation metadata.'
    )
    fullDescription: Optional[MultiformatMessageString] = Field(
        None, description='A comprehensive description of the translation metadata.'
    )
    downloadUri: Optional[AnyUrl] = Field(
        None,
        description='The absolute URI from which the translation metadata can be downloaded.',
    )
    informationUri: Optional[AnyUrl] = Field(
        None,
        description='The absolute URI from which information related to the translation metadata can be downloaded.',
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the translation metadata.',
    )


class ArtifactContent(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    text: Optional[str] = Field(
        None, description='UTF-8-encoded content from a text artifact.'
    )
    binary: Optional[str] = Field(
        None,
        description='MIME Base64-encoded content from a binary artifact, or from a text artifact in its original encoding.',
    )
    rendered: Optional[MultiformatMessageString] = Field(
        None,
        description='An alternate rendered representation of the artifact (e.g., a decompiled representation of a binary region).',
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the artifact content.',
    )


class ArtifactLocation(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    uri: Optional[str] = Field(
        None, description='A string containing a valid relative or absolute URI.'
    )
    uriBaseId: Optional[str] = Field(
        None,
        description='A string which indirectly specifies the absolute URI with respect to which a relative URI in the "uri" property is interpreted.',
    )
    index: Optional[conint(ge=-1)] = Field(
        -1,
        description='The index within the run artifacts array of the artifact object associated with the artifact location.',
    )
    description: Optional[Message] = Field(
        None, description='A short description of the artifact location.'
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the artifact location.',
    )


class ConfigurationOverride(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    configuration: ReportingConfiguration = Field(
        ...,
        description='Specifies how the rule or notification was configured during the scan.',
    )
    descriptor: ReportingDescriptorReference = Field(
        ...,
        description='A reference used to locate the descriptor whose configuration was overridden.',
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the configuration override.',
    )


class Edge(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    id: str = Field(
        ..., description='A string that uniquely identifies the edge within its graph.'
    )
    label: Optional[Message] = Field(
        None, description='A short description of the edge.'
    )
    sourceNodeId: str = Field(
        ...,
        description='Identifies the source node (the node at which the edge starts).',
    )
    targetNodeId: str = Field(
        ..., description='Identifies the target node (the node at which the edge ends).'
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the edge.',
    )


class EdgeTraversal(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    edgeId: str = Field(..., description='Identifies the edge being traversed.')
    message: Optional[Message] = Field(
        None, description='A message to display to the user as the edge is traversed.'
    )
    finalState: Optional[Dict[str, MultiformatMessageString]] = Field(
        None,
        description='The values of relevant expressions after the edge has been traversed.',
    )
    stepOverEdgeCount: Optional[conint(ge=0)] = Field(
        None,
        description='The number of edge traversals necessary to return from a nested graph.',
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the edge traversal.',
    )


class ExternalPropertyFileReference(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    location: Optional[ArtifactLocation] = Field(
        None, description='The location of the external property file.'
    )
    guid: Optional[
        constr(
            pattern=r'^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-5][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}$'
        )
    ] = Field(
        None,
        description='A stable, unique identifer for the external property file in the form of a GUID.',
    )
    itemCount: Optional[conint(ge=-1)] = Field(
        -1,
        description='A non-negative integer specifying the number of items contained in the external property file.',
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the external property file.',
    )


class ExternalPropertyFileReferences(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    conversion: Optional[ExternalPropertyFileReference] = Field(
        None,
        description='An external property file containing a run.conversion object to be merged with the root log file.',
    )
    graphs: Optional[List[ExternalPropertyFileReference]] = Field(
        [],
        description='An array of external property files containing a run.graphs object to be merged with the root log file.',
        min_length=0,
    )
    externalizedProperties: Optional[ExternalPropertyFileReference] = Field(
        None,
        description='An external property file containing a run.properties object to be merged with the root log file.',
    )
    artifacts: Optional[List[ExternalPropertyFileReference]] = Field(
        [],
        description='An array of external property files containing run.artifacts arrays to be merged with the root log file.',
        min_length=0,
    )
    invocations: Optional[List[ExternalPropertyFileReference]] = Field(
        [],
        description='An array of external property files containing run.invocations arrays to be merged with the root log file.',
        min_length=0,
    )
    logicalLocations: Optional[List[ExternalPropertyFileReference]] = Field(
        [],
        description='An array of external property files containing run.logicalLocations arrays to be merged with the root log file.',
        min_length=0,
    )
    threadFlowLocations: Optional[List[ExternalPropertyFileReference]] = Field(
        [],
        description='An array of external property files containing run.threadFlowLocations arrays to be merged with the root log file.',
        min_length=0,
    )
    results: Optional[List[ExternalPropertyFileReference]] = Field(
        [],
        description='An array of external property files containing run.results arrays to be merged with the root log file.',
        min_length=0,
    )
    taxonomies: Optional[List[ExternalPropertyFileReference]] = Field(
        [],
        description='An array of external property files containing run.taxonomies arrays to be merged with the root log file.',
        min_length=0,
    )
    addresses: Optional[List[ExternalPropertyFileReference]] = Field(
        [],
        description='An array of external property files containing run.addresses arrays to be merged with the root log file.',
        min_length=0,
    )
    driver: Optional[ExternalPropertyFileReference] = Field(
        None,
        description='An external property file containing a run.driver object to be merged with the root log file.',
    )
    extensions: Optional[List[ExternalPropertyFileReference]] = Field(
        [],
        description='An array of external property files containing run.extensions arrays to be merged with the root log file.',
        min_length=0,
    )
    policies: Optional[List[ExternalPropertyFileReference]] = Field(
        [],
        description='An array of external property files containing run.policies arrays to be merged with the root log file.',
        min_length=0,
    )
    translations: Optional[List[ExternalPropertyFileReference]] = Field(
        [],
        description='An array of external property files containing run.translations arrays to be merged with the root log file.',
        min_length=0,
    )
    webRequests: Optional[List[ExternalPropertyFileReference]] = Field(
        [],
        description='An array of external property files containing run.requests arrays to be merged with the root log file.',
        min_length=0,
    )
    webResponses: Optional[List[ExternalPropertyFileReference]] = Field(
        [],
        description='An array of external property files containing run.responses arrays to be merged with the root log file.',
        min_length=0,
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the external property files.',
    )


class GraphTraversal(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    runGraphIndex: Optional[conint(ge=-1)] = Field(
        -1,
        description='The index within the run.graphs to be associated with the result.',
    )
    resultGraphIndex: Optional[conint(ge=-1)] = Field(
        -1,
        description='The index within the result.graphs to be associated with the result.',
    )
    description: Optional[Message] = Field(
        None, description='A description of this graph traversal.'
    )
    initialState: Optional[Dict[str, MultiformatMessageString]] = Field(
        None,
        description='Values of relevant expressions at the start of the graph traversal that may change during graph traversal.',
    )
    immutableState: Optional[Dict[str, MultiformatMessageString]] = Field(
        None,
        description='Values of relevant expressions at the start of the graph traversal that remain constant for the graph traversal.',
    )
    edgeTraversals: Optional[List[EdgeTraversal]] = Field(
        [],
        description='The sequences of edges traversed by this graph traversal.',
        min_length=0,
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the graph traversal.',
    )


class LocationRelationship(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    target: conint(ge=0) = Field(
        ..., description='A reference to the related location.'
    )
    kinds: Optional[List[str]] = Field(
        ['relevant'],
        description="A set of distinct strings that categorize the relationship. Well-known kinds include 'includes', 'isIncludedBy' and 'relevant'.",
    )
    description: Optional[Message] = Field(
        None, description='A description of the location relationship.'
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the location relationship.',
    )


class Region(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    startLine: Optional[conint(ge=1)] = Field(
        None, description='The line number of the first character in the region.'
    )
    startColumn: Optional[conint(ge=1)] = Field(
        None, description='The column number of the first character in the region.'
    )
    endLine: Optional[conint(ge=1)] = Field(
        None, description='The line number of the last character in the region.'
    )
    endColumn: Optional[conint(ge=1)] = Field(
        None,
        description='The column number of the character following the end of the region.',
    )
    charOffset: Optional[conint(ge=-1)] = Field(
        -1,
        description='The zero-based offset from the beginning of the artifact of the first character in the region.',
    )
    charLength: Optional[conint(ge=0)] = Field(
        None, description='The length of the region in characters.'
    )
    byteOffset: Optional[conint(ge=-1)] = Field(
        -1,
        description='The zero-based offset from the beginning of the artifact of the first byte in the region.',
    )
    byteLength: Optional[conint(ge=0)] = Field(
        None, description='The length of the region in bytes.'
    )
    snippet: Optional[ArtifactContent] = Field(
        None,
        description='The portion of the artifact contents within the specified region.',
    )
    message: Optional[Message] = Field(
        None, description='A message relevant to the region.'
    )
    sourceLanguage: Optional[str] = Field(
        None,
        description='Specifies the source language, if any, of the portion of the artifact specified by the region object.',
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the region.',
    )


class Replacement(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    deletedRegion: Region = Field(
        ..., description='The region of the artifact to delete.'
    )
    insertedContent: Optional[ArtifactContent] = Field(
        None,
        description="The content to insert at the location specified by the 'deletedRegion' property.",
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the replacement.',
    )


class ReportingDescriptor(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    id: str = Field(..., description='A stable, opaque identifier for the report.')
    deprecatedIds: Optional[List[str]] = Field(
        None,
        description='An array of stable, opaque identifiers by which this report was known in some previous version of the analysis tool.',
        min_length=0,
    )
    guid: Optional[
        constr(
            pattern=r'^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-5][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}$'
        )
    ] = Field(
        None,
        description='A unique identifer for the reporting descriptor in the form of a GUID.',
    )
    deprecatedGuids: Optional[List[DeprecatedGuid]] = Field(
        None,
        description='An array of unique identifies in the form of a GUID by which this report was known in some previous version of the analysis tool.',
        min_length=0,
    )
    name: Optional[str] = Field(
        None, description='A report identifier that is understandable to an end user.'
    )
    deprecatedNames: Optional[List[str]] = Field(
        None,
        description='An array of readable identifiers by which this report was known in some previous version of the analysis tool.',
        min_length=0,
    )
    shortDescription: Optional[MultiformatMessageString] = Field(
        None,
        description='A concise description of the report. Should be a single sentence that is understandable when visible space is limited to a single line of text.',
    )
    fullDescription: Optional[MultiformatMessageString] = Field(
        None,
        description='A description of the report. Should, as far as possible, provide details sufficient to enable resolution of any problem indicated by the result.',
    )
    messageStrings: Optional[Dict[str, MultiformatMessageString]] = Field(
        None,
        description='A set of name/value pairs with arbitrary names. Each value is a multiformatMessageString object, which holds message strings in plain text and (optionally) Markdown format. The strings can include placeholders, which can be used to construct a message in combination with an arbitrary number of additional string arguments.',
    )
    defaultConfiguration: Optional[ReportingConfiguration] = Field(
        None, description='Default reporting configuration information.'
    )
    helpUri: Optional[AnyUrl] = Field(
        None,
        description='A URI where the primary documentation for the report can be found.',
    )
    help: Optional[MultiformatMessageString] = Field(
        None,
        description='Provides the primary documentation for the report, useful when there is no online documentation.',
    )
    relationships: Optional[List[ReportingDescriptorRelationship]] = Field(
        [],
        description='An array of objects that describe relationships between this reporting descriptor and others.',
        min_length=0,
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the report.',
    )


class SpecialLocations(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    displayBase: Optional[ArtifactLocation] = Field(
        None,
        description='Provides a suggestion to SARIF consumers to display file paths relative to the specified location.',
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the special locations.',
    )


class ToolComponent(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    guid: Optional[
        constr(
            pattern=r'^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-5][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}$'
        )
    ] = Field(
        None,
        description='A unique identifer for the tool component in the form of a GUID.',
    )
    name: str = Field(..., description='The name of the tool component.')
    organization: Optional[str] = Field(
        None,
        description='The organization or company that produced the tool component.',
    )
    product: Optional[str] = Field(
        None, description='A product suite to which the tool component belongs.'
    )
    productSuite: Optional[str] = Field(
        None,
        description='A localizable string containing the name of the suite of products to which the tool component belongs.',
    )
    shortDescription: Optional[MultiformatMessageString] = Field(
        None, description='A brief description of the tool component.'
    )
    fullDescription: Optional[MultiformatMessageString] = Field(
        None, description='A comprehensive description of the tool component.'
    )
    fullName: Optional[str] = Field(
        None,
        description='The name of the tool component along with its version and any other useful identifying information, such as its locale.',
    )
    version: Optional[str] = Field(
        None,
        description='The tool component version, in whatever format the component natively provides.',
    )
    semanticVersion: Optional[str] = Field(
        None,
        description='The tool component version in the format specified by Semantic Versioning 2.0.',
    )
    dottedQuadFileVersion: Optional[constr(pattern=r'[0-9]+(\.[0-9]+){3}')] = Field(
        None,
        description="The binary version of the tool component's primary executable file expressed as four non-negative integers separated by a period (for operating systems that express file versions in this way).",
    )
    releaseDateUtc: Optional[str] = Field(
        None,
        description="A string specifying the UTC date (and optionally, the time) of the component's release.",
    )
    downloadUri: Optional[AnyUrl] = Field(
        None,
        description='The absolute URI from which the tool component can be downloaded.',
    )
    informationUri: Optional[AnyUrl] = Field(
        None,
        description='The absolute URI at which information about this version of the tool component can be found.',
    )
    globalMessageStrings: Optional[Dict[str, MultiformatMessageString]] = Field(
        None,
        description='A dictionary, each of whose keys is a resource identifier and each of whose values is a multiformatMessageString object, which holds message strings in plain text and (optionally) Markdown format. The strings can include placeholders, which can be used to construct a message in combination with an arbitrary number of additional string arguments.',
    )
    notifications: Optional[List[ReportingDescriptor]] = Field(
        [],
        description='An array of reportingDescriptor objects relevant to the notifications related to the configuration and runtime execution of the tool component.',
        min_length=0,
    )
    rules: Optional[List[ReportingDescriptor]] = Field(
        [],
        description='An array of reportingDescriptor objects relevant to the analysis performed by the tool component.',
        min_length=0,
    )
    taxa: Optional[List[ReportingDescriptor]] = Field(
        [],
        description='An array of reportingDescriptor objects relevant to the definitions of both standalone and tool-defined taxonomies.',
        min_length=0,
    )
    locations: Optional[List[ArtifactLocation]] = Field(
        [],
        description='An array of the artifactLocation objects associated with the tool component.',
        min_length=0,
    )
    language: Optional[
        constr(pattern=r'^[a-zA-Z]{2}|^[a-zA-Z]{2}-[a-zA-Z]{2}]?$')
    ] = Field(
        'en-US',
        description='The language of the messages emitted into the log file during this run (expressed as an ISO 639-1 two-letter lowercase language code) and an optional region (expressed as an ISO 3166-1 two-letter uppercase subculture code associated with a country or region). The casing is recommended but not required (in order for this data to conform to RFC5646).',
    )
    contents: Optional[List[Content]] = Field(
        ['localizedData', 'nonLocalizedData'],
        description='The kinds of data contained in this object.',
    )
    isComprehensive: Optional[bool] = Field(
        False,
        description='Specifies whether this object contains a complete definition of the localizable and/or non-localizable data for this component, as opposed to including only data that is relevant to the results persisted to this log file.',
    )
    localizedDataSemanticVersion: Optional[str] = Field(
        None,
        description='The semantic version of the localized strings defined in this component; maintained by components that provide translations.',
    )
    minimumRequiredLocalizedDataSemanticVersion: Optional[str] = Field(
        None,
        description='The minimum value of localizedDataSemanticVersion required in translations consumed by this component; used by components that consume translations.',
    )
    associatedComponent: Optional[ToolComponentReference] = Field(
        None,
        description="The component which is strongly associated with this component. For a translation, this refers to the component which has been translated. For an extension, this is the driver that provides the extension's plugin model.",
    )
    translationMetadata: Optional[TranslationMetadata] = Field(
        None,
        description='Translation metadata, required for a translation, not populated by other component types.',
    )
    supportedTaxonomies: Optional[List[ToolComponentReference]] = Field(
        [],
        description='An array of toolComponentReference objects to declare the taxonomies supported by the tool component.',
        min_length=0,
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the tool component.',
    )


class VersionControlDetails(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    repositoryUri: AnyUrl = Field(
        ..., description='The absolute URI of the repository.'
    )
    revisionId: Optional[str] = Field(
        None,
        description='A string that uniquely and permanently identifies the revision within the repository.',
    )
    branch: Optional[str] = Field(
        None, description='The name of a branch containing the revision.'
    )
    revisionTag: Optional[str] = Field(
        None, description='A tag that has been applied to the revision.'
    )
    asOfTimeUtc: Optional[datetime] = Field(
        None,
        description='A Coordinated Universal Time (UTC) date and time that can be used to synchronize an enlistment to the state of the repository at that time.',
    )
    mappedTo: Optional[ArtifactLocation] = Field(
        None,
        description='The location in the local file system to which the root of the repository was mapped at the time of the analysis.',
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the version control details.',
    )


class WebRequest(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    index: Optional[conint(ge=-1)] = Field(
        -1,
        description='The index within the run.webRequests array of the request object associated with this result.',
    )
    protocol: Optional[str] = Field(
        None, description="The request protocol. Example: 'http'."
    )
    version: Optional[str] = Field(
        None, description="The request version. Example: '1.1'."
    )
    target: Optional[str] = Field(None, description='The target of the request.')
    method: Optional[str] = Field(
        None,
        description="The HTTP method. Well-known values are 'GET', 'PUT', 'POST', 'DELETE', 'PATCH', 'HEAD', 'OPTIONS', 'TRACE', 'CONNECT'.",
    )
    headers: Optional[Dict[str, str]] = Field(None, description='The request headers.')
    parameters: Optional[Dict[str, str]] = Field(
        None, description='The request parameters.'
    )
    body: Optional[ArtifactContent] = Field(
        None, description='The body of the request.'
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the request.',
    )


class WebResponse(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    index: Optional[conint(ge=-1)] = Field(
        -1,
        description='The index within the run.webResponses array of the response object associated with this result.',
    )
    protocol: Optional[str] = Field(
        None, description="The response protocol. Example: 'http'."
    )
    version: Optional[str] = Field(
        None, description="The response version. Example: '1.1'."
    )
    statusCode: Optional[int] = Field(
        None, description='The response status code. Example: 451.'
    )
    reasonPhrase: Optional[str] = Field(
        None, description="The response reason. Example: 'Not found'."
    )
    headers: Optional[Dict[str, str]] = Field(None, description='The response headers.')
    body: Optional[ArtifactContent] = Field(
        None, description='The body of the response.'
    )
    noResponseReceived: Optional[bool] = Field(
        False, description='Specifies whether a response was received from the server.'
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the response.',
    )


class Artifact(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    description: Optional[Message] = Field(
        None, description='A short description of the artifact.'
    )
    location: Optional[ArtifactLocation] = Field(
        None, description='The location of the artifact.'
    )
    parentIndex: Optional[conint(ge=-1)] = Field(
        -1,
        description='Identifies the index of the immediate parent of the artifact, if this artifact is nested.',
    )
    offset: Optional[conint(ge=0)] = Field(
        None,
        description='The offset in bytes of the artifact within its containing artifact.',
    )
    length: Optional[conint(ge=-1)] = Field(
        -1, description='The length of the artifact in bytes.'
    )
    roles: Optional[List[Role]] = Field(
        [],
        description='The role or roles played by the artifact in the analysis.',
        min_length=0,
    )
    mimeType: Optional[constr(pattern=r'[^/]+/.+')] = Field(
        None, description='The MIME type (RFC 2045) of the artifact.'
    )
    contents: Optional[ArtifactContent] = Field(
        None, description='The contents of the artifact.'
    )
    encoding: Optional[str] = Field(
        None,
        description='Specifies the encoding for an artifact object that refers to a text file.',
    )
    sourceLanguage: Optional[str] = Field(
        None,
        description='Specifies the source language for any artifact object that refers to a text file that contains source code.',
    )
    hashes: Optional[Dict[str, str]] = Field(
        None,
        description='A dictionary, each of whose keys is the name of a hash function and each of whose values is the hashed value of the artifact produced by the specified hash function.',
    )
    lastModifiedTimeUtc: Optional[datetime] = Field(
        None,
        description='The Coordinated Universal Time (UTC) date and time at which the artifact was most recently modified. See "Date/time properties" in the SARIF spec for the required format.',
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the artifact.',
    )


class ArtifactChange(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    artifactLocation: ArtifactLocation = Field(
        ..., description='The location of the artifact to change.'
    )
    replacements: List[Replacement] = Field(
        ...,
        description="An array of replacement objects, each of which represents the replacement of a single region in a single artifact specified by 'artifactLocation'.",
        min_length=1,
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the change.',
    )


class Attachment(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    description: Optional[Message] = Field(
        None, description='A message describing the role played by the attachment.'
    )
    artifactLocation: ArtifactLocation = Field(
        ..., description='The location of the attachment.'
    )
    regions: Optional[List[Region]] = Field(
        [],
        description='An array of regions of interest within the attachment.',
        min_length=0,
    )
    rectangles: Optional[List[Rectangle]] = Field(
        [],
        description='An array of rectangles specifying areas of interest within the image.',
        min_length=0,
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the attachment.',
    )


class Fix(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    description: Optional[Message] = Field(
        None,
        description='A message that describes the proposed fix, enabling viewers to present the proposed change to an end user.',
    )
    artifactChanges: List[ArtifactChange] = Field(
        ...,
        description='One or more artifact changes that comprise a fix for a result.',
        min_length=1,
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the fix.',
    )


class PhysicalLocation(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    address: Optional[Address] = Field(None, description='The address of the location.')
    artifactLocation: Optional[ArtifactLocation] = Field(
        None, description='The location of the artifact.'
    )
    region: Optional[Region] = Field(
        None, description='Specifies a portion of the artifact.'
    )
    contextRegion: Optional[Region] = Field(
        None,
        description='Specifies a portion of the artifact that encloses the region. Allows a viewer to display additional context around the region.',
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the physical location.',
    )


class ResultProvenance(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    firstDetectionTimeUtc: Optional[datetime] = Field(
        None,
        description='The Coordinated Universal Time (UTC) date and time at which the result was first detected. See "Date/time properties" in the SARIF spec for the required format.',
    )
    lastDetectionTimeUtc: Optional[datetime] = Field(
        None,
        description='The Coordinated Universal Time (UTC) date and time at which the result was most recently detected. See "Date/time properties" in the SARIF spec for the required format.',
    )
    firstDetectionRunGuid: Optional[
        constr(
            pattern=r'^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-5][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}$'
        )
    ] = Field(
        None,
        description='A GUID-valued string equal to the automationDetails.guid property of the run in which the result was first detected.',
    )
    lastDetectionRunGuid: Optional[
        constr(
            pattern=r'^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-5][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}$'
        )
    ] = Field(
        None,
        description='A GUID-valued string equal to the automationDetails.guid property of the run in which the result was most recently detected.',
    )
    invocationIndex: Optional[conint(ge=-1)] = Field(
        -1,
        description='The index within the run.invocations array of the invocation object which describes the tool invocation that detected the result.',
    )
    conversionSources: Optional[List[PhysicalLocation]] = Field(
        [],
        description="An array of physicalLocation objects which specify the portions of an analysis tool's output that a converter transformed into the result.",
        min_length=0,
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the result.',
    )


class Tool(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    driver: ToolComponent = Field(..., description='The analysis tool that was run.')
    extensions: Optional[List[ToolComponent]] = Field(
        [],
        description='Tool extensions that contributed to or reconfigured the analysis tool that was run.',
        min_length=0,
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the tool.',
    )


class Location(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    id: Optional[conint(ge=-1)] = Field(
        -1,
        description='Value that distinguishes this location from all other locations within a single result object.',
    )
    physicalLocation: Optional[PhysicalLocation] = Field(
        None, description='Identifies the artifact and region.'
    )
    logicalLocations: Optional[List[LogicalLocation]] = Field(
        [],
        description='The logical locations associated with the result.',
        min_length=0,
    )
    message: Optional[Message] = Field(
        None, description='A message relevant to the location.'
    )
    annotations: Optional[List[Region]] = Field(
        [], description='A set of regions relevant to the location.', min_length=0
    )
    relationships: Optional[List[LocationRelationship]] = Field(
        [],
        description='An array of objects that describe relationships between this location and others.',
        min_length=0,
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the location.',
    )


class Node(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    id: str = Field(
        ..., description='A string that uniquely identifies the node within its graph.'
    )
    label: Optional[Message] = Field(
        None, description='A short description of the node.'
    )
    location: Optional[Location] = Field(
        None, description='A code location associated with the node.'
    )
    children: Optional[List[Node]] = Field(
        [], description='Array of child nodes.', min_length=0
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the node.',
    )


class StackFrame(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    location: Optional[Location] = Field(
        None, description='The location to which this stack frame refers.'
    )
    module: Optional[str] = Field(
        None,
        description='The name of the module that contains the code of this stack frame.',
    )
    threadId: Optional[int] = Field(
        None, description='The thread identifier of the stack frame.'
    )
    parameters: Optional[List[str]] = Field(
        [], description='The parameters of the call that is executing.', min_length=0
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the stack frame.',
    )


class Suppression(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    guid: Optional[
        constr(
            pattern=r'^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-5][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}$'
        )
    ] = Field(
        None,
        description='A stable, unique identifer for the suprression in the form of a GUID.',
    )
    kind: Kind1 = Field(
        ..., description='A string that indicates where the suppression is persisted.'
    )
    state: Optional[State] = Field(
        None, description='A string that indicates the state of the suppression.'
    )
    justification: Optional[str] = Field(
        None, description='A string representing the justification for the suppression.'
    )
    location: Optional[Location] = Field(
        None, description='Identifies the location associated with the suppression.'
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the suppression.',
    )


class Graph(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    description: Optional[Message] = Field(
        None, description='A description of the graph.'
    )
    nodes: Optional[List[Node]] = Field(
        [],
        description='An array of node objects representing the nodes of the graph.',
        min_length=0,
    )
    edges: Optional[List[Edge]] = Field(
        [],
        description='An array of edge objects representing the edges of the graph.',
        min_length=0,
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the graph.',
    )


class Stack(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    message: Optional[Message] = Field(
        None, description='A message relevant to this call stack.'
    )
    frames: List[StackFrame] = Field(
        ...,
        description='An array of stack frames that represents a sequence of calls, rendered in reverse chronological order, that comprise the call stack.',
        min_length=0,
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the stack.',
    )


class ThreadFlowLocation(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    index: Optional[conint(ge=-1)] = Field(
        -1, description='The index within the run threadFlowLocations array.'
    )
    location: Optional[Location] = Field(None, description='The code location.')
    stack: Optional[Stack] = Field(
        None, description='The call stack leading to this location.'
    )
    kinds: Optional[List[str]] = Field(
        [],
        description="A set of distinct strings that categorize the thread flow location. Well-known kinds include 'acquire', 'release', 'enter', 'exit', 'call', 'return', 'branch', 'implicit', 'false', 'true', 'caution', 'danger', 'unknown', 'unreachable', 'taint', 'function', 'handler', 'lock', 'memory', 'resource', 'scope' and 'value'.",
        min_length=0,
    )
    taxa: Optional[List[ReportingDescriptorReference]] = Field(
        [],
        description='An array of references to rule or taxonomy reporting descriptors that are applicable to the thread flow location.',
        min_length=0,
    )
    module: Optional[str] = Field(
        None,
        description='The name of the module that contains the code that is executing.',
    )
    state: Optional[Dict[str, MultiformatMessageString]] = Field(
        None,
        description="A dictionary, each of whose keys specifies a variable or expression, the associated value of which represents the variable or expression value. For an annotation of kind 'continuation', for example, this dictionary might hold the current assumed values of a set of global variables.",
    )
    nestingLevel: Optional[conint(ge=0)] = Field(
        None,
        description='An integer representing a containment hierarchy within the thread flow.',
    )
    executionOrder: Optional[conint(ge=-1)] = Field(
        -1,
        description='An integer representing the temporal order in which execution reached this location.',
    )
    executionTimeUtc: Optional[datetime] = Field(
        None,
        description='The Coordinated Universal Time (UTC) date and time at which this location was executed.',
    )
    importance: Optional[Importance] = Field(
        'important',
        description='Specifies the importance of this location in understanding the code flow in which it occurs. The order from most to least important is "essential", "important", "unimportant". Default: "important".',
    )
    webRequest: Optional[WebRequest] = Field(
        None, description='A web request associated with this thread flow location.'
    )
    webResponse: Optional[WebResponse] = Field(
        None, description='A web response associated with this thread flow location.'
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the threadflow location.',
    )


class Exception(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kind: Optional[str] = Field(
        None,
        description='A string that identifies the kind of exception, for example, the fully qualified type name of an object that was thrown, or the symbolic name of a signal.',
    )
    message: Optional[str] = Field(
        None, description='A message that describes the exception.'
    )
    stack: Optional[Stack] = Field(
        None, description='The sequence of function calls leading to the exception.'
    )
    innerExceptions: Optional[List[Exception]] = Field(
        [],
        description='An array of exception objects each of which is considered a cause of this exception.',
        min_length=0,
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the exception.',
    )


class Notification(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    locations: Optional[List[Location]] = Field(
        [], description='The locations relevant to this notification.', min_length=0
    )
    message: Message = Field(
        ..., description='A message that describes the condition that was encountered.'
    )
    level: Optional[Level] = Field(
        'warning',
        description='A value specifying the severity level of the notification.',
    )
    threadId: Optional[int] = Field(
        None,
        description='The thread identifier of the code that generated the notification.',
    )
    timeUtc: Optional[datetime] = Field(
        None,
        description='The Coordinated Universal Time (UTC) date and time at which the analysis tool generated the notification.',
    )
    exception: Optional[Exception] = Field(
        None,
        description='The runtime exception, if any, relevant to this notification.',
    )
    descriptor: Optional[ReportingDescriptorReference] = Field(
        None,
        description='A reference used to locate the descriptor relevant to this notification.',
    )
    associatedRule: Optional[ReportingDescriptorReference] = Field(
        None,
        description='A reference used to locate the rule descriptor associated with this notification.',
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the notification.',
    )


class ThreadFlow(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    id: Optional[str] = Field(
        None,
        description='An string that uniquely identifies the threadFlow within the codeFlow in which it occurs.',
    )
    message: Optional[Message] = Field(
        None, description='A message relevant to the thread flow.'
    )
    initialState: Optional[Dict[str, MultiformatMessageString]] = Field(
        None,
        description='Values of relevant expressions at the start of the thread flow that may change during thread flow execution.',
    )
    immutableState: Optional[Dict[str, MultiformatMessageString]] = Field(
        None,
        description='Values of relevant expressions at the start of the thread flow that remain constant.',
    )
    locations: List[ThreadFlowLocation] = Field(
        ...,
        description="A temporally ordered array of 'threadFlowLocation' objects, each of which describes a location visited by the tool while producing the result.",
        min_length=1,
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the thread flow.',
    )


class CodeFlow(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    message: Optional[Message] = Field(
        None, description='A message relevant to the code flow.'
    )
    threadFlows: List[ThreadFlow] = Field(
        ...,
        description='An array of one or more unique threadFlow objects, each of which describes the progress of a program through a thread of execution.',
        min_length=1,
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the code flow.',
    )


class Invocation(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    commandLine: Optional[str] = Field(
        None, description='The command line used to invoke the tool.'
    )
    arguments: Optional[List[str]] = Field(
        None,
        description='An array of strings, containing in order the command line arguments passed to the tool from the operating system.',
        min_length=0,
    )
    responseFiles: Optional[List[ArtifactLocation]] = Field(
        None,
        description="The locations of any response files specified on the tool's command line.",
        min_length=0,
    )
    startTimeUtc: Optional[datetime] = Field(
        None,
        description='The Coordinated Universal Time (UTC) date and time at which the run started. See "Date/time properties" in the SARIF spec for the required format.',
    )
    endTimeUtc: Optional[datetime] = Field(
        None,
        description='The Coordinated Universal Time (UTC) date and time at which the run ended. See "Date/time properties" in the SARIF spec for the required format.',
    )
    exitCode: Optional[int] = Field(None, description='The process exit code.')
    ruleConfigurationOverrides: Optional[List[ConfigurationOverride]] = Field(
        [],
        description='An array of configurationOverride objects that describe rules related runtime overrides.',
        min_length=0,
    )
    notificationConfigurationOverrides: Optional[List[ConfigurationOverride]] = Field(
        [],
        description='An array of configurationOverride objects that describe notifications related runtime overrides.',
        min_length=0,
    )
    toolExecutionNotifications: Optional[List[Notification]] = Field(
        [],
        description='A list of runtime conditions detected by the tool during the analysis.',
        min_length=0,
    )
    toolConfigurationNotifications: Optional[List[Notification]] = Field(
        [],
        description="A list of conditions detected by the tool that are relevant to the tool's configuration.",
        min_length=0,
    )
    exitCodeDescription: Optional[str] = Field(
        None, description='The reason for the process exit.'
    )
    exitSignalName: Optional[str] = Field(
        None, description='The name of the signal that caused the process to exit.'
    )
    exitSignalNumber: Optional[int] = Field(
        None,
        description='The numeric value of the signal that caused the process to exit.',
    )
    processStartFailureMessage: Optional[str] = Field(
        None,
        description='The reason given by the operating system that the process failed to start.',
    )
    executionSuccessful: bool = Field(
        ...,
        description="Specifies whether the tool's execution completed successfully.",
    )
    machine: Optional[str] = Field(
        None, description='The machine that hosted the analysis tool run.'
    )
    account: Optional[str] = Field(
        None, description='The account that ran the analysis tool.'
    )
    processId: Optional[int] = Field(
        None, description='The process id for the analysis tool run.'
    )
    executableLocation: Optional[ArtifactLocation] = Field(
        None,
        description="An absolute URI specifying the location of the analysis tool's executable.",
    )
    workingDirectory: Optional[ArtifactLocation] = Field(
        None, description='The working directory for the analysis tool run.'
    )
    environmentVariables: Optional[Dict[str, str]] = Field(
        None,
        description='The environment variables associated with the analysis tool process, expressed as key/value pairs.',
    )
    stdin: Optional[ArtifactLocation] = Field(
        None,
        description='A file containing the standard input stream to the process that was invoked.',
    )
    stdout: Optional[ArtifactLocation] = Field(
        None,
        description='A file containing the standard output stream from the process that was invoked.',
    )
    stderr: Optional[ArtifactLocation] = Field(
        None,
        description='A file containing the standard error stream from the process that was invoked.',
    )
    stdoutStderr: Optional[ArtifactLocation] = Field(
        None,
        description='A file containing the interleaved standard output and standard error stream from the process that was invoked.',
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the invocation.',
    )


class Result(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    ruleId: Optional[str] = Field(
        None,
        description='The stable, unique identifier of the rule, if any, to which this notification is relevant. This member can be used to retrieve rule metadata from the rules dictionary, if it exists.',
    )
    ruleIndex: Optional[conint(ge=-1)] = Field(
        -1,
        description='The index within the tool component rules array of the rule object associated with this result.',
    )
    rule: Optional[ReportingDescriptorReference] = Field(
        None,
        description='A reference used to locate the rule descriptor relevant to this result.',
    )
    kind: Optional[Kind] = Field(
        'fail', description='A value that categorizes results by evaluation state.'
    )
    level: Optional[Level] = Field(
        'warning', description='A value specifying the severity level of the result.'
    )
    message: Message = Field(
        ...,
        description='A message that describes the result. The first sentence of the message only will be displayed when visible space is limited.',
    )
    analysisTarget: Optional[ArtifactLocation] = Field(
        None,
        description='Identifies the artifact that the analysis tool was instructed to scan. This need not be the same as the artifact where the result actually occurred.',
    )
    locations: Optional[List[Location]] = Field(
        [],
        description='The set of locations where the result was detected. Specify only one location unless the problem indicated by the result can only be corrected by making a change at every specified location.',
        min_length=0,
    )
    guid: Optional[
        constr(
            pattern=r'^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-5][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}$'
        )
    ] = Field(
        None,
        description='A stable, unique identifer for the result in the form of a GUID.',
    )
    correlationGuid: Optional[
        constr(
            pattern=r'^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-5][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}$'
        )
    ] = Field(
        None,
        description='A stable, unique identifier for the equivalence class of logically identical results to which this result belongs, in the form of a GUID.',
    )
    occurrenceCount: Optional[conint(ge=1)] = Field(
        None,
        description='A positive integer specifying the number of times this logically unique result was observed in this run.',
    )
    partialFingerprints: Optional[Dict[str, str]] = Field(
        None,
        description='A set of strings that contribute to the stable, unique identity of the result.',
    )
    fingerprints: Optional[Dict[str, str]] = Field(
        None,
        description='A set of strings each of which individually defines a stable, unique identity for the result.',
    )
    stacks: Optional[List[Stack]] = Field(
        [],
        description="An array of 'stack' objects relevant to the result.",
        min_length=0,
    )
    codeFlows: Optional[List[CodeFlow]] = Field(
        [],
        description="An array of 'codeFlow' objects relevant to the result.",
        min_length=0,
    )
    graphs: Optional[List[Graph]] = Field(
        [],
        description='An array of zero or more unique graph objects associated with the result.',
        min_length=0,
    )
    graphTraversals: Optional[List[GraphTraversal]] = Field(
        [],
        description="An array of one or more unique 'graphTraversal' objects.",
        min_length=0,
    )
    relatedLocations: Optional[List[Location]] = Field(
        [], description='A set of locations relevant to this result.', min_length=0
    )
    suppressions: Optional[List[Suppression]] = Field(
        None, description='A set of suppressions relevant to this result.', min_length=0
    )
    baselineState: Optional[BaselineState] = Field(
        None,
        description='The state of a result relative to a baseline of a previous run.',
    )
    rank: Optional[confloat(ge=-1.0, le=100.0)] = Field(
        -1.0,
        description='A number representing the priority or importance of the result.',
    )
    attachments: Optional[List[Attachment]] = Field(
        [], description='A set of artifacts relevant to the result.', min_length=0
    )
    hostedViewerUri: Optional[AnyUrl] = Field(
        None, description='An absolute URI at which the result can be viewed.'
    )
    workItemUris: Optional[List[AnyUrl]] = Field(
        None,
        description='The URIs of the work items associated with this result.',
        min_length=0,
    )
    provenance: Optional[ResultProvenance] = Field(
        None, description='Information about how and when the result was detected.'
    )
    fixes: Optional[List[Fix]] = Field(
        [],
        description="An array of 'fix' objects, each of which represents a proposed fix to the problem indicated by the result.",
        min_length=0,
    )
    taxa: Optional[List[ReportingDescriptorReference]] = Field(
        [],
        description='An array of references to taxonomy reporting descriptors that are applicable to the result.',
        min_length=0,
    )
    webRequest: Optional[WebRequest] = Field(
        None, description='A web request associated with this result.'
    )
    webResponse: Optional[WebResponse] = Field(
        None, description='A web response associated with this result.'
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the result.',
    )


class Conversion(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    tool: Tool = Field(..., description='A tool object that describes the converter.')
    invocation: Optional[Invocation] = Field(
        None,
        description='An invocation object that describes the invocation of the converter.',
    )
    analysisToolLogFiles: Optional[List[ArtifactLocation]] = Field(
        [],
        description="The locations of the analysis tool's per-run log files.",
        min_length=0,
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the conversion.',
    )


class ExternalProperties(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    schema_: Optional[AnyUrl] = Field(
        None,
        alias='schema',
        description='The URI of the JSON schema corresponding to the version of the external property file format.',
    )
    version: Optional[Version] = Field(
        None, description='The SARIF format version of this external properties object.'
    )
    guid: Optional[
        constr(
            pattern=r'^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-5][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}$'
        )
    ] = Field(
        None,
        description='A stable, unique identifer for this external properties object, in the form of a GUID.',
    )
    runGuid: Optional[
        constr(
            pattern=r'^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-5][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}$'
        )
    ] = Field(
        None,
        description='A stable, unique identifer for the run associated with this external properties object, in the form of a GUID.',
    )
    conversion: Optional[Conversion] = Field(
        None, description='A conversion object that will be merged with a separate run.'
    )
    graphs: Optional[List[Graph]] = Field(
        [],
        description='An array of graph objects that will be merged with a separate run.',
        min_length=0,
    )
    externalizedProperties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information that will be merged with a separate run.',
    )
    artifacts: Optional[List[Artifact]] = Field(
        None,
        description='An array of artifact objects that will be merged with a separate run.',
        min_length=0,
    )
    invocations: Optional[List[Invocation]] = Field(
        [],
        description='Describes the invocation of the analysis tool that will be merged with a separate run.',
        min_length=0,
    )
    logicalLocations: Optional[List[LogicalLocation]] = Field(
        [],
        description='An array of logical locations such as namespaces, types or functions that will be merged with a separate run.',
        min_length=0,
    )
    threadFlowLocations: Optional[List[ThreadFlowLocation]] = Field(
        [],
        description='An array of threadFlowLocation objects that will be merged with a separate run.',
        min_length=0,
    )
    results: Optional[List[Result]] = Field(
        [],
        description='An array of result objects that will be merged with a separate run.',
        min_length=0,
    )
    taxonomies: Optional[List[ToolComponent]] = Field(
        [],
        description='Tool taxonomies that will be merged with a separate run.',
        min_length=0,
    )
    driver: Optional[ToolComponent] = Field(
        None,
        description='The analysis tool object that will be merged with a separate run.',
    )
    extensions: Optional[List[ToolComponent]] = Field(
        [],
        description='Tool extensions that will be merged with a separate run.',
        min_length=0,
    )
    policies: Optional[List[ToolComponent]] = Field(
        [],
        description='Tool policies that will be merged with a separate run.',
        min_length=0,
    )
    translations: Optional[List[ToolComponent]] = Field(
        [],
        description='Tool translations that will be merged with a separate run.',
        min_length=0,
    )
    addresses: Optional[List[Address]] = Field(
        [],
        description='Addresses that will be merged with a separate run.',
        min_length=0,
    )
    webRequests: Optional[List[WebRequest]] = Field(
        [],
        description='Requests that will be merged with a separate run.',
        min_length=0,
    )
    webResponses: Optional[List[WebResponse]] = Field(
        [],
        description='Responses that will be merged with a separate run.',
        min_length=0,
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the external properties.',
    )


class Run(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    tool: Tool = Field(
        ...,
        description='Information about the tool or tool pipeline that generated the results in this run. A run can only contain results produced by a single tool or tool pipeline. A run can aggregate results from multiple log files, as long as context around the tool run (tool command-line arguments and the like) is identical for all aggregated files.',
    )
    invocations: Optional[List[Invocation]] = Field(
        [], description='Describes the invocation of the analysis tool.', min_length=0
    )
    conversion: Optional[Conversion] = Field(
        None,
        description="A conversion object that describes how a converter transformed an analysis tool's native reporting format into the SARIF format.",
    )
    language: Optional[
        constr(pattern=r'^[a-zA-Z]{2}|^[a-zA-Z]{2}-[a-zA-Z]{2}]?$')
    ] = Field(
        'en-US',
        description='The language of the messages emitted into the log file during this run (expressed as an ISO 639-1 two-letter lowercase culture code) and an optional region (expressed as an ISO 3166-1 two-letter uppercase subculture code associated with a country or region). The casing is recommended but not required (in order for this data to conform to RFC5646).',
    )
    versionControlProvenance: Optional[List[VersionControlDetails]] = Field(
        [],
        description='Specifies the revision in version control of the artifacts that were scanned.',
        min_length=0,
    )
    originalUriBaseIds: Optional[Dict[str, ArtifactLocation]] = Field(
        None,
        description='The artifact location specified by each uriBaseId symbol on the machine where the tool originally ran.',
    )
    artifacts: Optional[List[Artifact]] = Field(
        None,
        description='An array of artifact objects relevant to the run.',
        min_length=0,
    )
    logicalLocations: Optional[List[LogicalLocation]] = Field(
        [],
        description='An array of logical locations such as namespaces, types or functions.',
        min_length=0,
    )
    graphs: Optional[List[Graph]] = Field(
        [],
        description='An array of zero or more unique graph objects associated with the run.',
        min_length=0,
    )
    results: Optional[List[Result]] = Field(
        None,
        description='The set of results contained in an SARIF log. The results array can be omitted when a run is solely exporting rules metadata. It must be present (but may be empty) if a log file represents an actual scan.',
        min_length=0,
    )
    automationDetails: Optional[RunAutomationDetails] = Field(
        None, description='Automation details that describe this run.'
    )
    runAggregates: Optional[List[RunAutomationDetails]] = Field(
        [],
        description='Automation details that describe the aggregate of runs to which this run belongs.',
        min_length=0,
    )
    baselineGuid: Optional[
        constr(
            pattern=r'^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-5][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}$'
        )
    ] = Field(
        None,
        description="The 'guid' property of a previous SARIF 'run' that comprises the baseline that was used to compute result 'baselineState' properties for the run.",
    )
    redactionTokens: Optional[List[str]] = Field(
        [],
        description='An array of strings used to replace sensitive information in a redaction-aware property.',
        min_length=0,
    )
    defaultEncoding: Optional[str] = Field(
        None,
        description='Specifies the default encoding for any artifact object that refers to a text file.',
    )
    defaultSourceLanguage: Optional[str] = Field(
        None,
        description='Specifies the default source language for any artifact object that refers to a text file that contains source code.',
    )
    newlineSequences: Optional[List[str]] = Field(
        ['\r\n', '\n'],
        description='An ordered list of character sequences that were treated as line breaks when computing region information for the run.',
        min_length=1,
    )
    columnKind: Optional[ColumnKind] = Field(
        None, description='Specifies the unit in which the tool measures columns.'
    )
    externalPropertyFileReferences: Optional[ExternalPropertyFileReferences] = Field(
        None,
        description='References to external property files that should be inlined with the content of a root log file.',
    )
    threadFlowLocations: Optional[List[ThreadFlowLocation]] = Field(
        [],
        description='An array of threadFlowLocation objects cached at run level.',
        min_length=0,
    )
    taxonomies: Optional[List[ToolComponent]] = Field(
        [],
        description='An array of toolComponent objects relevant to a taxonomy in which results are categorized.',
        min_length=0,
    )
    addresses: Optional[List[Address]] = Field(
        [],
        description='Addresses associated with this run instance, if any.',
        min_length=0,
    )
    translations: Optional[List[ToolComponent]] = Field(
        [],
        description='The set of available translations of the localized data provided by the tool.',
        min_length=0,
    )
    policies: Optional[List[ToolComponent]] = Field(
        [],
        description="Contains configurations that may potentially override both reportingDescriptor.defaultConfiguration (the tool's default severities) and invocation.configurationOverrides (severities established at run-time from the command line).",
        min_length=0,
    )
    webRequests: Optional[List[WebRequest]] = Field(
        [], description='An array of request objects cached at run level.', min_length=0
    )
    webResponses: Optional[List[WebResponse]] = Field(
        [],
        description='An array of response objects cached at run level.',
        min_length=0,
    )
    specialLocations: Optional[SpecialLocations] = Field(
        None,
        description='A specialLocations object that defines locations of special significance to SARIF consumers.',
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the run.',
    )


class StaticAnalysisResultsFormatSarifVersion210JsonSchema(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    field_schema: Optional[AnyUrl] = Field(
        None,
        alias='$schema',
        description='The URI of the JSON schema corresponding to the version.',
    )
    version: Version = Field(
        ..., description='The SARIF format version of this log file.'
    )
    runs: List[Run] = Field(
        ..., description='The set of runs contained in this log file.', min_length=0
    )
    inlineExternalProperties: Optional[List[ExternalProperties]] = Field(
        None,
        description='References to external property files that share data between runs.',
        min_length=0,
    )
    properties: Optional[PropertyBag] = Field(
        None,
        description='Key/value pairs that provide additional information about the log file.',
    )


Node.model_rebuild()
Exception.model_rebuild()
